#ifndef SRC_UTIL_H_
#define SRC_UTIL_H_

#include <ACS_ZDoom.h>
#include <stdio.h>
#include <stdlib.h>

#define ASPECT_4_3 1.33333333333
#define ASPECT_5_4 1.25
#define ASPECT_16_9 1.77777777778
#define ASPECT_16_10 1.6
#define ASPECT_17_10 1.7

#define HudMessage(flags, id, color, x, y, hold, opt1, opt2, opt3, ...) \
( \
	ACS_BeginHudMessage(), \
	__nprintf(__VA_ARGS__), \
	ACS_MoreHudMessage(), \
	ACS_OptHudMessage(flags, id, color, x, y, hold), \
	ACS_EndHudMessageXXX(opt1, opt2, opt3) \
)

#define PrintBold(...) \
( \
	ACS_BeginPrintBold(), \
	__nprintf(__VA_ARGS__), \
	ACS_EndPrint() \
)

#define Print(...) \
( \
	ACS_BeginPrint(), \
	__nprintf(__VA_ARGS__), \
	ACS_EndPrint() \
)

#define StrParam(...) \
( \
	ACS_BeginStrParam(), \
	__nprintf(__VA_ARGS__), \
	ACS_EndStrParam() \
)

#define PrintSprite(spr, id, x, y, delay) \
( \
	ACS_SetFont(spr), \
	HudMessage(HUDMSG_PLAIN, id, CR_UNTRANSLATED, x, y, delay, 0.0, 0.0, 0.0, "A") \
)

#define ClearMessage(id) \
( \
	HudMessage(HUDMSG_PLAIN, id, CR_UNTRANSLATED, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, "") \
)

#define Log(...) \
( \
	ACS_BeginLog(), \
	__nprintf(__VA_ARGS__), \
	ACS_EndLog() \
)

#define PrintName(n) \
( \
	ACS_BeginPrint(), \
	ACS_PrintName(n), \
	ACS_EndStrParam() \
)

#define StrParamL(...) \
( \
	StrParam("%LS", StrParam(__VA_ARGS__)) \
)

#define ctoastr(cstr) \
( \
	ACS_BeginStrParam(), \
	__nprintf(cstr), \
	ACS_EndStrParam() \
)

char *astrtoc(__str s);
__str astrupper(__str s);
__str astrlower(__str s);
int astrtoi(__str s);
void FreezePlayer();
void UnFreezePlayer();
double GetAspectRatio();
double GetAspectScale();
bool KeyPressed(int k);
bool KeyReleased(int k);

#endif // SRC_UTIL_H_
