
// Copyright Ben Moir 2016
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef _VECTOR_H
#define _VECTOR_H

typedef struct vector_t
{
	void *data;
	size_t tsize;
	size_t count;
	size_t capacity;
	
	void(*push_back)(struct vector_t *, void *);
	void(*pop_back)(struct vector_t *);
	void *(*back)(struct vector_t *);
	void *(*front)(struct vector_t *);
	void(*reserve)(struct vector_t *, size_t);
	void(*insert)(struct vector_t *, size_t, void *);
	void(*remove)(struct vector_t *, size_t);
	void *(*at)(struct vector_t *, size_t);
} vector_t;

[[__optional_args(1)]]
vector_t *new_vector(size_t tsize, size_t default_capacity);

#endif // _VECTOR_H
