#ifndef SRC_VNS_H_
#define SRC_VNS_H_

#include "vector.h"

typedef struct action_t
{
	int opcode;
	int args;
	int *argv;
} action_t;

typedef struct script_t
{
	int num_strings;
	int num_actions;
	action_t *actions;
	__str *strings;
	__str name;
} script_t;

typedef struct vnframe_t
{
	int type;
	int words;
	__str text;
	__str name;
	__str portrait;
	__str font;
} vnframe_t;

typedef struct vns_t
{
	bool loaded;
	int num_scripts;
	script_t *scripts;
	vector_t *frames;
	__str *name;
	__str *portrait;
	__str *font;
} vns_t;

enum
{
	OP_NOP,
	OP_NAME,
	OP_PORTRAIT,
	OP_FONT,
	OP_TEXT,
	OP_CHOICE_START,
	OP_CHOICE_ADD,
	OP_CHOICE_END,
	OP_END,
	OP_SCRIPT,
	OP_WAITTEXT,
	OP_WAIT,
};

enum
{
	VNS_DIALOGUE,
	VNS_CHOICE,
	VNS_CG,
};

[[call("SScriptS")]] typedef int(*opfunc_t)(script_t *, int, int, int, int *);

[[call("SScriptS")]] int opNop(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opName(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opPortrait(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opFont(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opText(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opChoiceStart(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opChoiceAdd(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opChoiceEnd(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opEnd(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opScript(script_t *, int, int, int, int *);
[[call("SScriptS")]] int opWaitText(script_t *s, int pn, int tid, int argc, int *argv);
[[call("SScriptS")]] int opWait(script_t *s, int pn, int tid, int argc, int *argv);

#endif // SRC_VNS_H_
